<?php

namespace App\Controllers\Admin;

use App\Helpers\UserHelper;
use App\Models\UserModel;

use CodeIgniter\HTTP\DownloadResponse;
use CodeIgniter\HTTP\RedirectResponse;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use CodeIgniter\Validation\Validation;
use Psr\Log\LoggerInterface;

class UserController extends AdminController
{
    private $_model = null;
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->class_name = "User";
        $this->class_path .= $this->class_name;
        $this->title = lang("{$this->class_path}.title");
        $this->helper = new UserHelper();
    }
    protected function getModel(): UserModel
    {
        if ($this->_model === null) {
            $this->_model = new UserModel();
        }
        return $this->_model;
    }
    protected function setFormFieldRule($field, Validation $validation, string $action): Validation
    {
        switch ($field) {
            case 'role':
                //아래 Rule Array는 필드명.* checkbox를 사용
                $validation->setRule($field . ".*", $field, $this->getModel()->getFieldRule($action, $field));
                break;
            default:
                $validation = parent::setFormFieldRule($field, $validation, $action);
                break;
        }
        return $validation;
    }
    protected function getFormFieldOption(string $field, array $options = []): array
    {
        switch ($field) {
            default:
                $options = parent::getFormFieldOption($field, $options);
                break;
        }
        return $options;
    }
    protected function getFormData(string $field, array $formDatas): array
    {
        switch ($field) {
            case 'role':
                $roles = $this->request->getVar($field) ?? [];
                if (!count($roles)) {
                    throw new \Exception("권한이 지정되지 않았습니다.");
                }
                $formDatas[$field] = implode(DEFAULTS["DELIMITER_ROLE"], $roles);
                break;
            case 'passwd': //데이터가 있을때면 formData에 넣어줌 : 수정시에는 않넣을수도 있어야하므로
                $passwd = $this->request->getVar($field);
                if ($passwd) {
                    $formDatas[$field] = $passwd;
                }
                break;
            case 'confirmpassword':
                $confirmpassword = $this->request->getVar($field);
                if ($confirmpassword) {
                    $formDatas[$field] = $confirmpassword;
                }
                break;
            default:
                $formDatas = parent::getFormData($field, $formDatas);
                break;
        }
        return $formDatas;
    }
    private function init(string $action): void
    {
        $this->action = $action;
        $this->fields = ['id', 'passwd', 'confirmpassword', $this->getModel()::TITLE, 'email', 'mobile', 'role'];
        $this->field_rules = $this->getModel()->getFieldRules($this->action, $this->fields);
        $this->filter_fields = ['role', 'status'];
        $this->field_options = $this->getFormFieldOptions($this->filter_fields);
    }
    //생성
    public function create_form(): RedirectResponse|string
    {
        $this->init('create');
        return $this->create_form_procedure();
    }
    public function create(): RedirectResponse|string
    {
        $this->init(__FUNCTION__);
        return $this->create_procedure();
    }
    //수정
    public function modify_form(string $uid): RedirectResponse|string
    {
        $this->init('modify');
        return $this->modify_form_procedure($uid);
    }
    public function modify(string $uid): RedirectResponse|string
    {
        $this->init(__FUNCTION__);
        return $this->modify_procedure($uid);
    }
    //일괄작업
    public function batcjob(): RedirectResponse
    {
        $this->action = __FUNCTION__;
        $this->fields = ['status'];
        $this->field_rules = $this->getModel()->getFieldRules($this->action, $this->fields);
        return $this->batcjob_procedure();
    }
    //  리스트
    public function index(): string
    {
        $this->action = __FUNCTION__;
        $this->fields = ['id', $this->getModel()::TITLE, 'email', 'mobile', 'role', 'status'];
        $this->field_rules = $this->getModel()->getFieldRules($this->action, $this->fields);
        $this->filter_fields = ['role', 'status'];
        $this->field_options = $this->getFormFieldOptions($this->filter_fields);
        $this->batchjob_fields = ['status'];
        return $this->list_procedure();
    }
    // Download
    public function download(string $output_type, $uid = false): DownloadResponse|string
    {
        $this->action = __FUNCTION__;
        $this->fields = ['id', $this->getModel()::TITLE, 'email', 'mobile', 'role', 'status'];
        $this->field_rules = $this->getModel()->getFieldRules($this->action, $this->fields);
        $this->filter_fields = ['role', 'status'];
        $this->field_options = $this->getFormFieldOptions($this->filter_fields);
        $this->batchjob_fields = ['status'];
        return $this->download_procedure($output_type, $uid);
    }
}
